#ifndef CUZ_DB_H
#define CUZ_DB_H

#include "sqlite3.h"
#include <string>
#include <vector>
#include <map>

typedef std::vector<std::string> DBParams;
typedef std::map<std::string,std::string> DBRow;
typedef std::vector<DBRow> DBResult;

struct DBWrap {
    sqlite3 *_db;
    int error;
    
    DBWrap() { this->_db = 0; this->error = 0; }
    void open(const char *fname);
    DBResult query(const char *sql,DBParams params = DBParams());
    void close();
    void begin(); void commit();
    virtual ~DBWrap() { this->close(); }

};

#endif
