#ifndef CUZ_EVENT_H
#define CUZ_EVENT_H

enum { EVT_NONE,
EVT_QUIT,EVT_SUSPEND,EVT_RESUME,EVT_RESIZE, // window
EVT_KEYDOWN,EVT_KEYUP, // keyboard
EVT_DOWN,EVT_MOTION,EVT_UP, // motion
EVT_WHEEL,
EVT_ACCEL,EVT_ORIENT, // accelerometer
EVT_JOYBUTTON,EVT_JOYAXIS, // joystick
EVT_FOCUS,EVT_BLUR,EVT_ENTER,EVT_EXIT,EVT_CLICK, // gui events
EVT_SDLEVENT, // other ??
EVT_MAX };

// NOTE: not all keys are supported on all (or any) platforms yet.
enum {
    KEY_NONE,
    KEY_UP,KEY_RIGHT,KEY_DOWN,KEY_LEFT,
    
    KEY_ESCAPE,KEY_BACKSPACE,KEY_DELETE,KEY_RETURN,
    KEY_HOME,KEY_END,
    
    KEY_F1,KEY_F2,KEY_F3,KEY_F4,KEY_F5,KEY_F6,
    KEY_F7,KEY_F8,KEY_F9,KEY_F10,KEY_F11,KEY_F12,
    
    KEY_TAB,
    
    KEY_P0,KEY_P1,KEY_P2,KEY_P3,KEY_P4,
    KEY_P5,KEY_P6,KEY_P7,KEY_P8,KEY_P9,
    
    KEY_a,KEY_b,KEY_c,KEY_d,KEY_e,KEY_f,KEY_g,KEY_h,KEY_i,
    KEY_j,KEY_k,KEY_l,KEY_m,KEY_n,KEY_o,KEY_p,KEY_q,KEY_r,
    KEY_s,KEY_t,KEY_u,KEY_v,KEY_w,KEY_x,KEY_y,KEY_z,
    
    KEY_0,KEY_1,KEY_2,KEY_3,KEY_4,KEY_5,KEY_6,KEY_7,KEY_8,KEY_9,
    KEY_MAX
};

#define KEYM_SHIFT 1
#define KEYM_CTRL 2
#define KEYM_ALT 4
#define KEYM_OPT 8


struct Event {
    int type;
    float x,y,z,dx,dy,dz;//,cx,cy;
    float w,h;
    float _x,_y,_z,_dx,_dy,_dz;
    int b,v,c,t;
    int stype; int device;
    
    Event(int type=EVT_NONE) {
        this->type = type;
        this->stype = 0;
        this->x = 0; this->y=0; this->z = 0; 
        this->b = 0; 
        this->dx=0; this->dy=0; this->dz=0;
        this->v = 0; this->c = 0;
		this->device = 0;
		this->_x = 0;this->_y = 0;this->_z = 0;
		this->_dx = 0; this->_dy=0; this->_dz=0;
        //this->cx = 0;this->cy=0;
        this->t = 0;
    }
};


#endif
