#ifndef CUZ_FONT_H
#define CUZ_FONT_H

#include "cuz_gfx.h"

struct FontInfo {
    int n;
    int tex;
    GfxRect chars[256];
    float height;
    GfxRect rect;
};

void font_init();

void font_deinit();

int font_load(const char *fname);

float font_get_height(int fid, const char *s=0, float w=0);

float font_get_width(int fid, const char *s);

void font_draw(int fid, const char *s, float x, float y, float w=0, int align=-1);

// this function returns the rect where the character at pos will be rendered
GfxRect font_crect(int fid, const char *s, int pos, float w=0, int align=-1);

// this function finds the character that is nearest to the coordinates given
int font_cnear(int fid, const char *s, int x, int y, float w = 0, int align=-1);
#endif
