#ifndef GAME_H
#define GAME_H

#include "version.h"
#include "cuz_event.h"

enum {
    STATE_NONE,
    STATE_TEST,
};

struct State {
    virtual void init() { }
    virtual void deinit() { }
    virtual void paint() { }
    virtual void event(Event e) { }
    virtual void loop() { }
    virtual ~State() { } 
};

enum {
    ACTION_NONE,
    ACTION_TEST,
};

// place in whatever methods would be handy
struct Action {
    virtual void test() { }
    virtual ~Action();
};

struct Settings {
    int version;
    char name[64];
    char passwd[64];
    int music,sfx;
    char uid[64];
    char udid[64];
    int vres,vfull;
    // always add new items to the end and
};

struct LevelData {
    int version;
};


struct Game {
    // the core data
    int version;
    int state, parent, context; 
    LevelData level;
    
    // reloaded each time
    Settings settings;
    
    // must be reset each time
    int quit;
    int _fs_toggle_tmp;
    
    void init() ;
    void paint();
    void loop();
    void event(Event e);
    void next(int _state);
    void deinit();
    
    void video_reset();
    void open_url(const char *s);
    void settings_sync();
    void play_sound(const char *name);
    void play_music(const char *name);
    void stop_music();
    void volume_reset();
    
    void register_state(int v, State *state);
    void register_action(const char *, Action *action);
};

#endif
