#include <stdio.h>

#include "game.h"
#include "cuz_font.h"
#include "cuz_gfx.h"
#include "cuz_mixer.h"
#include "cuz_gui.h"


struct Test : State {
    Game &game;
    Container gui;
    Test(Game &_game) : game(_game) { }
    
    void init() {
        Widget *w;
        gui.add(w=new TextInput(Font(font_load("font1")),"input"),0,100);
        w->style.width = 200;
    }
    
    void event(Event e) {
        gui.event(&e);
        if (e.type == EVT_KEYDOWN) {
            game.play_sound("death");
        }
    }
    
    void paint() {
    
        gfx_set_size(GAME_SW,GAME_SH);
        gfx_clear();
        gfx_ortho();
        
        gui.resize();
        gui.paint();
    
        int fnt = font_load("font1");
        
        font_draw(fnt,"hello world",0,0);
        
        int img;
        img = gfx_img_load("img1");
        gfx_img_blit(img,200,200);
        
        img = gfx_img_load("img2");
        gfx_img_blit(img,400,400);
    
        img = gfx_img_load("img3");
        gfx_img_blit(img,600,600);
        
        int tex;
        tex = gfx_tex_load("atlas1");
        gfx_tex_blit(tex,800,200,100,100);
        tex = gfx_tex_load("img4");
        gfx_tex_blit(tex,800,400,100,100);
        tex = gfx_tex_load("font.png");
        gfx_tex_blit(tex,800,600,100,100);
        
        
        
        
    }
};



void hello_init(Game &game) {
    game.register_state(STATE_TEST,new Test(game));
}