#ifndef VERSION_H
#define VERSION_H

#define GAME_SW 1024
#define GAME_SH 768
#define GAME_FPS 60

#define GAME_STATE_VERSION 1
#define GAME_STATE_FNAME "state.dat"
#define GAME_VERSION "1.0.0"
#define GAME_API_VERSION "1"
#define GAME_TITLE "Game Title"
#define GAME_WEB_LINK "http://www.galcon.com/"
#define GAME_SETTINGS_VERSION 1
#define GAME_SETTINGS_FNAME "settings.dat"
 
#if defined(BUILD_DESKTOP)
#define _GAME_BUILD "Desktop"
#elif defined(BUILD_TOUCH)
#define _GAME_BUILD "Touch"
#else
#error "BUILD_ not defined"
#endif

#if defined(PLATFORM_OSX)
#define _GAME_PLATFORM "OSX"
#define GAME_NAME "GameName.app"
#elif defined(PLATFORM_WIN32)
#define _GAME_PLATFORM "Win32"
#define GAME_NAME "GameName"
#elif defined(PLATFORM_LINUX)
#define _GAME_PLATFORM "Linux"
#define GAME_NAME "gamename"
#elif defined(PLATFORM_IOS)
#define _GAME_PLATFORM "iOS"
#define GAME_NAME "Example"
#else
#error "PLATFORM_ not defined"
#endif

#if defined(USING_STEAM)
#define _GAME_SOCIAL "Steamworks"
#elif defined(USING_GAMECENTER)
#define _GAME_SOCIAL "GameCenter"
#elif defined(USING_GALCON)
#define _GAME_SOCIAL "GALCON.COM"
#else
#error "USING_social not defined"
#endif

#define GAME_VERSION_INFO GAME_VERSION "-" _GAME_BUILD "-" _GAME_PLATFORM "-" _GAME_SOCIAL

#endif
